<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Auth;
use Socialite;
use App\Models\User;

class AuthController extends Controller
{
    
    public function form()
    {
       return view('login');
    }
   
    public function check(Request $request)
    {
       $email = $request->input('email', '');
       $password = $request->input('password', '');     
       if (!Auth::attempt([
           'email' => $email,
           'password' => $password,
       ])) {
           return response()->redirectToAction('AuthController@form')->with('error', true);
       }
       $intented = session('url_intended');
       return response()->redirectTo($intented ?? '/');
    }
   
    public function redirectGoogleOauth()
    {
        return Socialite::driver('google')->redirect();
    }
    
    public function redirectGithubOauth()
    {
        return Socialite::driver('github')->redirect();
    }
   
    public function oauthGoogle()
    {
       $user = Socialite::driver('google')->user();
       $email = $user->getEmail();
       $token = $user->token;
       $user = User::firstOrCreate(['email' => $email, 'password' => 'oauthGoogle']);
       Auth::login($user);
       $intented = session('url_intended');
       return response()->redirectTo($intented ?? '/');
    }
    
    public function oauthGithub()
    {
       $user = Socialite::driver('github')->user();       
       $email = $user->getEmail();
       $token = $user->token;
       $user = User::firstOrCreate(['email' => $email, 'password' => 'oauthGithub']);
       Auth::login($user);
       $intented = session('url_intended');
       return response()->redirectTo($intented ?? '/');
    }
   
    public function logout()
    {
       Auth::logout();
       return response()->redirectToAction('AuthController@form');
    }
}
