<?php

namespace App\Models;
use Illuminate\Database\Eloquent\Model;

class Group extends Model {        
    
    public function users()
    {
        return $this->belongsToMany('App\Models\User')->withTimestamps();
    }
    
    public function hasRole($role, $resourceName)
    {    
        //$resources = $this->resources()->wherePivot('role', $role)->where('name', $resourceName);        
        $resources = $this->resources;
        foreach ($resources as $resource) {
            if ($resource->pivot->role == $role && $resourceName == $resource->name) {
                return true;
            }
        }
        return false;
    }
    
    public function resources()
    {
        return $this
                    ->belongsToMany('App\Models\Resource', 'roles')
                    ->withTimestamps()
                    ->withPivot('role');
    }
}
