<?php

namespace App\Models;

use Illuminate\Notifications\Notifiable;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;
        

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'email', 'password',
    ];
    
    protected $hidden = [
        'password', 'deleted_at'
    ];        

    
public function hasRole($role, $resourceName)
    {        
        $groups = $this->groups;
        foreach ($groups as $group) {
            if ($group->hasRole($role, $resourceName)) {
                return true;
            }
        }
        return false;
    }
    
    public function groups()
    {
        return $this->belongsToMany('App\Models\Group')->withTimestamps();
    }        
    
    public function setAttribute($key, $value)
    {
        $isRememberTokenAttribute = $key == $this->getRememberTokenName();
        if (!$isRememberTokenAttribute) {
            parent::setAttribute($key, $value);
        }
    }
    
    public function news()
    {
        return $this->hasMany('App\Models\News');
    }

}
