<?php
namespace App\Ws\Controllers;
use Auth as LaraAuth;
use Request;
use App\Ws\RouterAuth;
use App\Models\User;

class Auth { 
    
    public function login(RouterAuth $router, $from)
    {        
        $email = Request::input('email', '');
        $password = Request::input('password', '');     
        if (!LaraAuth::once([
            'email' => $email,
            'password' => $password,
        ])) {
            $router->sendData("loginFailed", "login failed", $from);
        } else {
            $loggedUser = User::where('email', $email)->first();
            $from->user = $loggedUser->toArray();
            $router->addAuthClient($from);
            $router->sendData("login", "login ok", $from);
            $router->sendDataToAllAuth("connection", [
                'email' => $from->user['email'],
                'id' => $from->user['id'],
            ]);
        }
    }
    
    public function logout(RouterAuth $router, $from)
    {
        $router->removeAuthClient($from);
        $router->sendData("logout", "logout successfull", $from);
    }
    
}
