<?php
namespace App\Ws\Controllers;
use App\Ws\RouterAuth;
use App\Services\Normalize;

class Command { 
    
    public static function time(RouterAuth $router, $from, $cmdPara)
    {
        $router->sendData('system', ['msg' => date("d.m.Y")], $from);
    }        
    
    public static function ping(RouterAuth $router, $from, $cmdPara)
    {
        $router->sendData('system', ['msg' => 'pong'], $from);
    }
    
    public static function msg(RouterAuth $router, $from, $cmdPara)
    {
        $cmdParaData = explode(" ", $cmdPara);
        $paraEmail = $cmdParaData[0];        
        $paraMsg = trim(str_replace($paraEmail, '', $cmdPara));        
        $normalize = resolve(Normalize::class);
        $clientsFound = [];
        foreach ($router->getAuthClients() as $client) {
            if ($normalize->compare($paraEmail, $client->user['email'], Normalize::SECONDARY) == 0) {
                $clientsFound[] = $client;
            }
        }
        if (count($clientsFound) == 0){
            $router->sendData('system', ['msg' => 'User not found'], $from);
            return;
        }
        $router->sendData('system', ['msg' => 'sending message to ' . $paraEmail], $from);
        foreach ($clientsFound as $client) {
            $router->sendData('send', [
                'email' => $from->user['email'],
                'msg' => $paraMsg,
                'private' => true,
            ], $client);
        }
    }
    
    public static function murloc(RouterAuth $router, $from, $cmdPara)
    {
        $replace = [
            'a' => 'mm', 'b' => 'gr', 'c' => 'ml', 'd' => 'lr',
            'e' => 'il', 'f' => 'ke', 'g' => 'rl', 'h' => 'rw',
            'i' => 'll', 'j' => 're', 'k' => 'ru', 'l' => 'ul',
            'm' => 'gl', 'n' => 'lu', 'o' => 'uu', 'p' => 'ek',
            'q' => 'rg', 'r' => 'lm', 's' => 'wr', 't' => 'ch',
            'u' => 'mu', 'v' => 'er', 'w' => 'lg', 'x' => 'ug',
            'y' => 'gu', 'z' => 'ub',
        ];
        $normalize = resolve(Normalize::class);
        $msg = $normalize->removeDicaritic($cmdPara);
        $msg = $normalize->removeLigature($cmdPara);        
        $msg = strtr(mb_strtolower($msg), $replace);
        $router->sendDataToAllAuth('send', [
            'email' => $from->user['email'],
            'msg' => "*murloc* " . $msg,            
        ]);
    }    
    
    public static function demurl(RouterAuth $router, $from, $cmdPara)
    {
        $replace = array_flip([
            'a' => 'mm', 'b' => 'gr', 'c' => 'ml', 'd' => 'lr',
            'e' => 'il', 'f' => 'ke', 'g' => 'rl', 'h' => 'rw',
            'i' => 'll', 'j' => 're', 'k' => 'ru', 'l' => 'ul',
            'm' => 'gl', 'n' => 'lu', 'o' => 'uu', 'p' => 'ek',
            'q' => 'rg', 'r' => 'lm', 's' => 'wr', 't' => 'ch',
            'u' => 'mu', 'v' => 'er', 'w' => 'lg', 'x' => 'ug',
            'y' => 'gu', 'z' => 'ub',
        ]);                  
        $msg = strtr(mb_strtolower($cmdPara), $replace);        
        $router->sendData('system', ['msg' => $msg], $from);
    }
    
}
